--[[
-- table compatible library (2006/04/04)
table.lua table݊Cu

T|[g
table.sort
table.concat

the author is null. by Ȟ
http://blog.livedoor.jp/aidev/

documentation by silica as ~̐l
http://winter.sgv417.jp/
--]]
if not table then
	
	local internal = {}	-- Ԃ̍Č
	
	table = {}
	
	function table.setn( t, n )
		if t.n then
			t.n = n
		else
			internal[ t ] = n
		end
	end
	
	function table.getn( t )
		if t.n then return t.n end
		if internal[ t ] then return internal[ t ] end
		local n = 0
		for i, v in ipairs( t ) do
			n = i
		end
		return n
	end
	
	function table.insert( t, pos, value )
		local n = table.getn( t )
		if not value then
			value = pos
			pos = n + 1	-- ftHgl
		else
			assert( pos >= 1 and pos <= n + 1 )	-- L͈͂`FbN
		end
		for i = n, pos, -1 do 	-- ̗vf炷
			t[i+1] = t[i]
		end
		t[ pos ] = value
		table.setn( t, n + 1 )
	end
	
	function table.remove( t, pos )
		local n = table.getn( t )
		assert( not pos or pos >= 1 and pos <= n )	-- L͈͂`FbN
		if not pos then pos = n end	-- ftHgl
		t[ pos ] = nil
		for i = pos, n, 1 do	-- t[n]  nil ŏ㏑
			t[i] = t[i+1]
		end
		table.setn( t, n - 1 )
	end
	
	function table.foreach( t, f )
		for k,v in pairs( t ) do
			local r = f( k, v )
			if r ~= nil then
				return r
			end
		end
	end
	
	function table.foreachi( t, f )
		for i = 1, table.getn( t ) do
			local r = f( i, t[i] )
			if r ~= nil then
				return r
			end
		end
	end
end
